---
title: ParentNode.lastElementChild
slug: Web/API/ParentNode/lastElementChild
tags:
  - API
  - DOM
  - ParentNode
  - Property
  - Reference
  - polyfill
---
<div>{{ APIRef("DOM") }}</div>

<p>The <code><strong>ParentNode.lastElementChild</strong></code> read-only property returns the object's last child {{domxref("Element")}} or {{jsxref("null")}} if there are no child elements.</p>

<div class="note">
<p><strong>Note:</strong> This property was initially defined in the {{domxref("ElementTraversal")}} pure interface. As this interface contained two distinct set of properties, one aimed at {{domxref("Node")}} that have children, one at those that are children, they have been moved into two separate pure interfaces, {{domxref("ParentNode")}} and {{domxref("ChildNode")}}. In this case, <code>lastElementChild</code> moved to <code>ParentNode</code>. This is a fairly technical change that shouldn't affect compatibility.</p>
</div>

<h2 id="Syntax_and_values">Syntax</h2>

<pre class="syntaxbox">const <em>element</em> = node.lastElementChild</pre>

<h2 id="Example">Example</h2>

<pre class="brush: html">&lt;ul id="foo"&gt;
  &lt;li&gt;First  (1)&lt;/li&gt;
  &lt;li&gt;Second (2)&lt;/li&gt;
  &lt;li&gt;Third  (3)&lt;/li&gt;
&lt;/ul&gt;

&lt;script&gt;
const foo = document.getElementById('foo');
console.log(foo.lastElementChild.textContent); // logs: Third (3)
&lt;/script&gt;
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>The code below adds support of <code>lastElementChild()</code> to <code>Document</code> and <code>DocumentFragment</code> in Internet Explorer and Safari.</p>

<pre class="brush: js">// Overwrites native 'lastElementChild' prototype.
// Returns array instead of HTMLCollection.
;(function(constructor) {
  if(constructor &amp;&amp;
    constructor.prototype &amp;&amp;
    constructor.prototype.lastElementChild == null) {
    Object.defineProperty(constructor.prototype, 'lastElementChild', {
      get: function() {
        var node, nodes = this.childNodes, i = nodes.length - 1;
        while(node = nodes[i--]) {
          if(node.nodeType === 1) {
            return node;
          }
        }
        return null;
      }
    });
  }
})(window.Node || window.Element);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-parentnode-lastelementchild', 'ParentNode.lastElementChild')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Splitted the <code>ElementTraversal</code> interface in {{domxref("ChildNode")}} and <code>ParentNode</code>. This method is now defined on the latter.<br>
    The {{domxref("Document")}} and {{domxref("DocumentFragment")}} implemented the new interfaces.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ParentNode.lastElementChild")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("ParentNode")}} and {{domxref("ChildNode")}} pure interfaces.</li>
 <li>
  <div class="syntaxbox">Object types implementing this pure interface: {{domxref("Document")}}, {{domxref("Element")}}, and {{domxref("DocumentFragment")}}.</div>
 </li>
</ul>
